QCA::RSAContext Class Referenceabstract
QCA provider API

`#include <QtCrypto>`

Collaboration diagram for QCA::RSAContext:
[legend]

## Public Member Functions

virtual void | createPrivate (const BigInteger &n, const BigInteger &e, const BigInteger &p, const BigInteger &q, const BigInteger &d)=0
virtual void | createPrivate (int bits, int exp, bool block)=0
virtual void | createPublic (const BigInteger &n, const BigInteger &e)=0
virtual BigInteger | d () const =0
virtual BigInteger | e () const =0
virtual BigInteger | n () const =0
virtual BigInteger | p () const =0
virtual BigInteger | q () const =0
| RSAContext (Provider *p)
Public Member Functions inherited from QCA::PKeyBase
virtual int | bits () const =0
virtual bool | canExport () const =0
virtual void | convertToPublic ()=0
virtual bool | decrypt (const SecureArray &in, SecureArray *out, EncryptionAlgorithm alg)
virtual SymmetricKey | deriveKey (const PKeyBase &theirs)
virtual SecureArray | encrypt (const SecureArray &in, EncryptionAlgorithm alg)
virtual QByteArray | endSign ()
virtual bool | endVerify (const QByteArray &sig)
virtual bool | isNull () const =0
virtual bool | isPrivate () const =0
virtual int | maximumEncryptSize (EncryptionAlgorithm alg) const
| PKeyBase (Provider *p, const QString &type)
virtual void | startSign (SignatureAlgorithm alg, SignatureFormat format)
virtual void | startVerify (SignatureAlgorithm alg, SignatureFormat format)
virtual PKey::Type | type () const =0
virtual void | update (const MemoryRegion &in)
Public Member Functions inherited from QCA::Provider::Context
virtual Context * | clone () const =0
Provider * | provider () const
bool | sameProvider (const Context *c) const
QString | type () const

## Additional Inherited Members

Signals inherited from QCA::PKeyBase
void | finished ()
Protected Member Functions inherited from QCA::BasicContext
| BasicContext (const BasicContext &from)
| BasicContext (Provider *parent, const QString &type)
Protected Member Functions inherited from QCA::Provider::Context
| Context (const Context &from)
| Context (Provider *parent, const QString &type)

## Detailed Description

RSA provider.

Note
  This class is part of the provider plugin interface and should not be used directly by applications. You probably want RSAPublicKey or RSAPrivateKey instead.

## Constructor & Destructor Documentation

## RSAContext()

QCA::RSAContext::RSAContext | ( | Provider * | p | ) |

inline

Standard constructor.

Parameters

  p | the provider associated with this context

References p(), and QCA::PKeyBase::PKeyBase().

## Member Function Documentation

## createPrivate() [1/2]

virtual void QCA::RSAContext::createPrivate | ( | int | bits,
|  | int | exp,
|  | bool | block )

pure virtual

Generate an RSA private key.

If block is true, then this function blocks until completion. Otherwise, this function returns immediately and finished() is emitted when the operation completes.

If an error occurs during generation, then the operation will complete and isNull() will return true.

Parameters

  bits | the length of the key to generate, in bits
  exp | the exponent to use for generation
  block | whether to use blocking mode

References QCA::PKeyBase::bits().

## createPrivate() [2/2]

virtual void QCA::RSAContext::createPrivate | ( | const BigInteger & | n,
|  | const BigInteger & | e,
|  | const BigInteger & | p,
|  | const BigInteger & | q,
|  | const BigInteger & | d )

pure virtual

Create an RSA private key based on the five components.

Parameters

  n | the N parameter
  e | the public exponent
  p | the P parameter
  q | the Q parameter
  d | the D parameter

References d(), e(), n(), p(), and q().

## createPublic()

virtual void QCA::RSAContext::createPublic | ( | const BigInteger & | n,
|  | const BigInteger & | e )

pure virtual

Create an RSA public key based on the two public components.

Parameters

  n | the N parameter
  e | the public exponent

References e(), and n().

## n()

virtual BigInteger QCA::RSAContext::n | ( |  | ) | const

pure virtual

Returns the public N component of this RSA key.

Referenced by createPrivate(), and createPublic().

## e()

virtual BigInteger QCA::RSAContext::e | ( |  | ) | const

pure virtual

Returns the public E component of this RSA key.

Referenced by createPrivate(), and createPublic().

## p()

virtual BigInteger QCA::RSAContext::p | ( |  | ) | const

pure virtual

Returns the private P component of this RSA key.

Referenced by createPrivate(), and RSAContext().

## q()

virtual BigInteger QCA::RSAContext::q | ( |  | ) | const

pure virtual

Returns the private Q component of this RSA key.

Referenced by createPrivate().

## d()

virtual BigInteger QCA::RSAContext::d | ( |  | ) | const

pure virtual

Returns the private D component of this RSA key.

Referenced by createPrivate().

The documentation for this class was generated from the following file:

- qcaprovider.h